/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Attention: the 'no copy' does not work, if sending a message in offline modus
//          (messages are delivered to the 'sent'-folder)

var gBase=0x100;
var gSentAlso=0x10;
var gTrash=0x20;
var gDefSent=0x1;

/* for TB3 see mailnews/base/public/nsMsgFolderFlags.idl
var gFlagList = { 'MSG_FOLDER_FLAG_VIRTUAL' : 0x0020,
                  'MSG_FOLDER_FLAG_TRASH' : 0x0100,
                  'MSG_FOLDER_FLAG_SENTMAIL' : 0x0200,
                  'MSG_FOLDER_FLAG_DRAFTS' : 0x0400,
                  'MSG_FOLDER_FLAG_QUEUE' : 0x0800,
                  'MSG_FOLDER_FLAG_INBOX' : 0x1000,
                  'MSG_FOLDER_FLAG_TEMPLATES' : 0x400000,
                  'MSG_FOLDER_FLAG_JUNK' : 0x40000000 };
*/
var gSpecialFolders=0x0100|0x0400|0x0800|0x400000|0x40000000;

var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].
        getService(Components.interfaces.nsIRDFService);
var dir = rdf.GetResource("moz-abdirectory://")
            .QueryInterface(Components.interfaces.nsIAbDirectory);
var TB3=dir.directoryProperties?false:true;  //true since TB3

//var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

var gPreSelected='';
var gMsgType;

var gChooseBehind=false;  //from preferences
var gAllowChoose=true;
var gNocopyTest=false;  //nocopy crash test?

var gDefaultLabel=null;
var gDefaultURI=null;

/////////////////////////////////////////////////////////////////////////////
// set the fcc_folder, so sendMsg will use it
function cs2c_prepareForCopy() {

  if (gMsgType==nsIMsgCompDeliverMode.SaveAsDraft ||
      gMsgType==nsIMsgCompDeliverMode.SaveAsTemplate ||
      gMsgType==nsIMsgCompDeliverMode.AutoSaveAsDraft )
    return;

//Get current identity
  var identity=window.getCurrentIdentity();
  if (!identity.doFcc || identity.fccFolderPickerMode<gBase)
    //no copy requested or copy to fixed folder (standard tb modes)
    return;

  var msgCompFields = gMsgCompose.compFields;
  // wenn kein to angegeben, liefert CheckValidEmailAddress() trotzdem true und
  // dies wird aufgerufen, obwohl daas senden spter niocht ausgefhrt wird!
  if (!msgCompFields.to) return

  // msgCompFields.fcc is empty
  var picker=document.getElementById('ggbs_cs2c_fccFolderPicker');
  if (!gPreSelected) {
    //If 'choose after send' is enabled, show the menu
    if (gChooseBehind && gAllowChoose) {
        //.open() throws exception!
      //var left=window.left+200;
      //var top=window.top+200;
      var chooser=window.openDialog("chrome://copysent2current/content/chooser.xul","cs2c_chooser",
          'chrome=yes,modal=yes,titlebar=yes,alwaysRaised=yes,dialog=yes,close=no',//,left='+left+',top='+top,
          gDefaultLabel, gDefaultURI);
    }
    var lastusedlabel=picker.getAttribute("label");
    var lastuseduri=picker.getAttribute("uri");
    if (lastuseduri!="nocopy://"
        && !(window.getCurrentIdentity().fccFolderPickerMode&gDefSent && lastuseduri==gDefaultURI)
                                       // nicht den sentfolder, wenn er der default ist
    ) {
      gCS2C.add(lastuseduri);
      if (!gChooseBehind)
        fillElems();
    }
    msgCompFields.fcc = lastuseduri;
  } else if (gPreSelected=='noCopy') {
    msgCompFields.fcc = "nocopy://";
  } else if (gPreSelected=='toSentFolder') {
    msgCompFields.fcc = identity.fccFolder;
  }
  gPreSelected='';

  // change nocopy:// to trash folder if requested
  if (TB3 && gNocopyTest)                       //nocopy crash test?
    identity.fccFolderPickerMode&=~gTrash;      //  nocopy is always a real nocopy
    else
  if (TB3)                                              //wg BUG in TB3 with nocopy://
    identity.fccFolderPickerMode|=gTrash;               //  nocopy is always copy to trash
  if (identity.fccFolderPickerMode&gTrash && msgCompFields.fcc=='nocopy://') {
    //find the Trash folder and be sure this folder is a trash folder
    var trashFolderURI=identity.fccFolder.replace(/[^\/]*$/,'Trash');
    /* check if trashfolder really is a trash folder */
    if (typeof MailUtils=='object') { //since TB3b3
      trashFolder=MailUtils.getFolderForURI(trashFolderURI);
    } else {  //TB2-TB3b2, Eudora
      trashFolder=GetMsgFolderFromUri(trashFolderURI);
    }
    var flags=Components.interfaces.nsMsgFolderFlags?
        Components.interfaces.nsMsgFolderFlags.Trash: //TB3
        0x0100;                                       //TB2: commandglue.js: var MSG_FOLDER_FLAG_TRASH = 0x0100;
    if (trashFolder.flags&flags) {
      msgCompFields.fcc=trashFolderURI;
    } else {
      var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
        getService(Components.interfaces.nsIPromptService);
      var strings = document.getElementById("ggbs_cs2c_strings");
      var ret=prompter.alert(window, strings.getString('CopySent2Current'), strings.getString('NoTrashFolder'));
      msgCompFields.fcc=identity.fccFolder;
    }
  }

  if (identity.fccFolderPickerMode&gSentAlso && msgCompFields.fcc != identity.fccFolder) { // also to sent folder
    if (msgCompFields.fcc=='nocopy://') {
      msgCompFields.fcc  = identity.fccFolder;
    }
    // since fcc2 is only performed when fcc succeeded, we want to be sure
    // that the 'easier'(=copy to a local folder) is done first
    else if (identity.fccFolder.substr(0,7)!='imap://' &&             // if send folder is local
               msgCompFields.fcc.substr(0,7)=='imap://') {            // and fcc folder is remote
      msgCompFields.fcc2 = msgCompFields.fcc;                         //   change them
      msgCompFields.fcc  = identity.fccFolder;
    } else {
      msgCompFields.fcc2 = identity.fccFolder;
    }
  }

dump('CopySent2Current: fcc  to '+msgCompFields.fcc+'\n');
dump('                  fcc2 to '+msgCompFields.fcc2+'\n');
}

//not really used!
function cs2c_SelectionChange(event, picker) {
  var uri=picker.getAttribute("uri");
}

/////////////////////////////////////////////////////////////////////////////
// preselect the current (or another) folder in the 'copy-to'-picker
// or hide the picker, if not useable
function cs2c_fillMenu(event, origURI) {
    //origURI: MessageURI if its a reply

  var menu=document.getElementById('ggbs_cs2c_toolbar');
  var identity=window.getCurrentIdentity();

  if (identity.doFcc && identity.fccFolderPickerMode>=gBase) {
    gAllowChoose=true;
    menu.hidden=gChooseBehind;
    var sendTo='';

    var folder;
    if (identity.fccFolderPickerMode&gDefSent)          // Sent folder is default
      sendTo=identity.fccFolder;
    else if (origURI) { //preselect current folder
       //for replies, current folder is the folder of the message replied to!
      try {
        var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
            QueryInterface(Components.interfaces.nsIMessenger);
        var msgHdr=messenger.msgHdrFromURI(origURI);
        folder=msgHdr.folder;
      } catch(e) { dump('cs2c: messenger: '+e+'\n'); }
    } else { //try to find the currently selected folder

      var mailWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                       .QueryInterface(Components.interfaces.nsIWindowMediator)
                       .getMostRecentWindow("mail:3pane");
      if (mailWindow) {     //else: no main window
        var View=mailWindow.gDBView;  //nsIMsgDBView
        if (View) {         // else: no folder selected!
          folder=View.msgFolder;
          // wenn 'new' geklicked
          //TB3b4: wenn tab mit message aktiv, ist das der folder der message,
          //         nicht der folder aus dem 3pane tab
          //       aus einem der neuen suchergebnis fenster gibts zwar den view,
          //         aber der hat keinen folder
          //       wenn message in eigenem Window (vom 3pane tab aus), sollte eventuell der folder
          //         der angezeigten message genommen werden, nicht aus 3pane window (kein Ahnung wie)
          //       wenn message in eigenem Window (aus suchergebnis heraus),
          //         gibts keinen folder
        }
      }
    }
    if (folder && folder.canFileMessages     // not news Folder, virtual folder
//        && !(folder.flags&gSpecialFolders)   // not a special folder
       )
         sendTo=folder.URI;
//else if (folder) alert('special folder');
//else if (!sendTo) alert('no folder');
    if (!sendTo) //last resort: preselect last used folder
      sendTo=identity.fccFolder;

    //Set chooser to the default (if choose behind: just to get uri and label!)
      //from chrome:://messenger/content/msgFolderPickerOverlay.js #88ff
    SetFolderPicker(sendTo, "ggbs_cs2c_fccFolderPicker");
    var picker=document.getElementById('ggbs_cs2c_fccFolderPicker');
    gDefaultLabel=picker.getAttribute("label");
    gDefaultURI=picker.getAttribute("uri");

    if (!gChooseBehind) {
      var menu=document.getElementById('ggbs_cs2c_copyMenuPopup');
      var def=menu.firstChild;
      def.label  = gDefaultLabel;
      def.id     = gDefaultURI;
      fillElems();
    }
  } else {
    gAllowChoose=false;
    menu.hidden=true;
  }
}

/////////////////////////////////////////////////////////////////////////////
function cs2c_picked(chooser, picked) {
  var uri=picked.id;
  var picker=document.getElementById('ggbs_cs2c_fccFolderPicker');
  if (uri=='nocopy://') {
    picker.setAttribute("label",picked.getAttribute("label"));
    picker.setAttribute("uri",uri);
  } else {
    //from chrome:://messenger/content/msgFolderPickerOverlay.js #88
    SetFolderPickerElement(uri, picker);
      //Does the following, and adds the '... in server' text to the picker
      //  picker.setAttribute("label",picked.getAttribute("label"));
      //  picker.setAttribute("uri",uri);
  }
  if (chooser) {
    chooser.close();
    chooser=null;
  }
//  var goto=document.getElementById('msgSubject'); //'content-frame');//
//  goto.focus();
}
function cs2c_showPopup() {
  // called via a timeout! This prevents using the keystroke as navigation in the popup,
  // if the menulist gots focus via keyboard-shortcut
  var popup=document.getElementById('ggbs_cs2c_copyMenuPopup');
  if (!TB3)
    popup.showPopup(popup,-1,-1,'popup','topleft','topleft'); //deprecated; use:
  else
    popup.openPopup(popup, 'after_start', -1, -1, false, false);
}

// Register a state listener so that we know, the message has been sent.
// reset the fcc_folder to the 'sent' folder

/*
var cs2c_stateListener = {
  NotifyComposeFieldsReady: function() {
//dump('NotifyComposeFieldsReady\n');
  },


  // Message send (or copied to outbox, if offline)
  ComposeProcessDone: function(aResult) {
//dump('ComposeProcessDone\n');
  },

  SaveInFolderDone: function(folderURI) {
//dump('SaveInFolderDone\n');
  }

};
*/

/////////////////////////////////////////////////////////////////////////////
function cs2c_init() {

  try {
    var ak_s = gPrefB.getCharPref("accesskey_send");
    document.getElementById('ggbs_cs2c_key_sendNoCopy').setAttribute('key',ak_s);
    document.getElementById('ggbs_cs2c_key_sendCopy2Sent').setAttribute('key',ak_s);
  } catch(e) { }

  //Overload functions
/*  (only, if we registered the state listener)
  var cs2c_ComposeUnload=window.ComposeUnload;
  // and replace with my version...
  window.ComposeUnload=function() {
//  if (gMsgCompose) gMsgCompose.UnregisterStateListener(cs2c_stateListener);
    return cs2c_ComposeUnload.apply(this, arguments);
  }
*/

    // Overload from chrome://messenger/content/msgComposeCommands.js @line 1646
    // so we have a chance to get the type of the message
    // because we do not want to set .fcc and .fcc2 on SaveAsDraft and others
  var cs2c_GenericSendMessage=window.GenericSendMessage;
  window.GenericSendMessage=function() {
    gMsgType=arguments[0];
    return cs2c_GenericSendMessage.apply(this, arguments);
  }

//  cs2c_fillMenu(null, null);    // and preselect the current folder in the copy to picker
}


/////////////////////////////////////////////////////////////////////////////
// Overload from chrome://messenger/content/msgComposeCommands.js @line 1163
// not via cs2c_init(), because that might be too late!
function ComposeStartup(recycled, aParams) {
  savedComposeStartup(recycled, aParams);               // call original
//  gMsgCompose.RegisterStateListener(cs2c_stateListener);  // i want to know state changes

  //see original ComposeStartup
  var params=null;
  var origURI=null;
  if (aParams)
    params = aParams;
  else
    if (window.arguments && window.arguments[0]) {
      try {
        if (window.arguments[0] instanceof Components.interfaces.nsIMsgComposeParams)
          params = window.arguments[0];
        else
          params = handleMailtoArgs(window.arguments[0]);
      }
      catch(ex) { dump("ERROR with parameters: " + ex + "\n"); }
    }
  if (params) origURI=params.originalMsgURI;
  try { gChooseBehind = gPrefB.getBoolPref("choosebehind"); }
    catch(e) { gChooseBehind=false; }

  if (!gChooseBehind) addElems();
  cs2c_fillMenu(null, origURI);    // and preselect the current folder in the copy to picker
  document.getElementById('fccMenu').disabled=true;

  //nocopy crash test?
  try { gNocopyTest = gPrefB.getBoolPref("nocopytest"); }
    catch(e) { gNocopyTest=false; }
}


var cs2cController =
{
  supportsCommand: function(command)
  {
//dump("cs2c: supportsCommand: "+command+"\n");
    switch (command)
    {
      case "ggbs_cs2c_cmd_sendNoCopy":
      case "ggbs_cs2c_cmd_sendCopy2Sent":
        return true;
      default:
        return false;
    }
  },
  isCommandEnabled: function(command)
  {
//dump("cs2c: isCommandEnabled: "+command+"\n");
    switch (command)
    {
      case "ggbs_cs2c_cmd_sendNoCopy":
      case "ggbs_cs2c_cmd_sendCopy2Sent":
        var identity=window.getCurrentIdentity();
        if (!identity.doFcc || identity.fccFolderPickerMode<gBase) return false;
        return !gWindowLocked;
      default:
        return false;
    }
  },

  doCommand: function(command)
  {
//dump("cs2c: doCommand: "+command+"\n");
    switch (command)
    {
      case "ggbs_cs2c_cmd_sendNoCopy":
        if (cs2cController.isCommandEnabled(command)) {
          gPreSelected='noCopy';
          if (gIOService && gIOService.offline)
            SendMessageLater();
          else
            SendMessage();
        }
        break;
      case "ggbs_cs2c_cmd_sendCopy2Sent":
        if (cs2cController.isCommandEnabled(command)) {
          gPreSelected='toSentFolder';
          if (gIOService && gIOService.offline)
            SendMessageLater();
          else
            SendMessage();
        }
        break;
      default:
//        savedDefaultController.doCommand(command);
        return;
    }
  },

  onEvent: function(event)
  {
//dump("DefaultController:onEvent\n");
    savedDefaultController.onEvent(event);
  }
}
top.controllers.insertControllerAt(0, cs2cController);

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", cs2c_init, false);


window.addEventListener('compose-from-changed', cs2c_fillMenu, true);   // change of identity! (last param must be true!)
window.addEventListener('compose-send-message', cs2c_prepareForCopy, true); // fires after the observer 'mail:composeOnSend'
//not necessary, because of 'ComposeStartup' called:
//window.addEventListener('compose-window-reopen', cs2c_fillMenu, true);




