/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gBase=0x100;
var gSentAlso=0x10;
var gTrash=0x20;
var gDefSent=0x1;

var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].
        getService(Components.interfaces.nsIRDFService);
var dir = rdf.GetResource("moz-abdirectory://")
            .QueryInterface(Components.interfaces.nsIAbDirectory);
var TB3=dir.directoryProperties?false:true;  //true since TB3

function gg_setPickersState(event)
{
    document.getElementById('msgFccAccountPicker').setAttribute("disabled", "true");
    document.getElementById('msgFccFolderPicker').setAttribute("disabled", "true");
    gg_gui("false");

    var radioElemValue = event.target.value;
    gFccRadioElemChoice = radioElemValue;

    var checker=document.getElementById('ggbs_cs2c_fcc2_toSend');
    if (checker.checked) gFccRadioElemChoice|=gSentAlso;
    checker=document.getElementById('ggbs_cs2c_fcc_noCopyIsTrash');
    if (TB3)                                              //wg BUG in TB3 with nocopy://
      checker.checked=true;                               // nocopy if copy to trash always set!
    if (checker.checked) gFccRadioElemChoice|=gTrash;

    var radio = document.getElementById("ggbs_cs2c_fcc_def");
    if (radio.selectedItem) {
      var defElemValue = radio.selectedItem.value;
      if (defElemValue!=0)
        gFccRadioElemChoice |= gDefSent;
      else
        gFccRadioElemChoice &= ~gDefSent;
    } else {
      radioElem = document.getElementById("ggbs_cs2c_fcc_defiscur");
      radioElem.radioGroup.selectedItem = radioElem;
    }
}
function gg_setCheckersState(event)
{
  if (gFccRadioElemChoice>=gBase) { //test should not be necessary
    var checkElemValue = event.target.checked;
    var bit=event.target.id=='ggbs_cs2c_fcc2_toSend'       ? gSentAlso :
            event.target.id=='ggbs_cs2c_fcc_noCopyIsTrash' ? gTrash    :
            0;
    if (TB3                                                  //wg BUG in TB3 with nocopy://
          && event.target.id=='ggbs_cs2c_fcc_noCopyIsTrash')
      checkElemValue=true;                                   // nocopy if copy to trash always set!
    if (checkElemValue)
      gFccRadioElemChoice |= bit;
    else
      gFccRadioElemChoice &= ~bit;
  }
}

function gg_setDefaultsState(event)
{
  if (gFccRadioElemChoice>=gBase) { //test should not be necessary
    var defElemValue = event.target.value;
    if (defElemValue!=0)
      gFccRadioElemChoice |= gDefSent;
    else
      gFccRadioElemChoice &= ~gDefSent;
  }
}

function gg_gui(disable) {
  document.getElementById('ggbs_cs2c_fcc2_toSend').setAttribute("disabled", disable);
  document.getElementById('ggbs_cs2c_fcc_noCopyIsTrash').setAttribute("disabled", disable);
  if (TB3)                                                                       //wg BUG in TB3 with nocopy://
    document.getElementById('ggbs_cs2c_fcc_noCopyIsTrash').setAttribute("disabled", true);  // always disabled

  var radio = document.getElementById("ggbs_cs2c_fcc_def");
//  radio.setAttribute("disabled", disable);  //does not work :-(
  for (var i=0; i<radio.childNodes.length; i++)
    radio.childNodes[i].setAttribute("disabled", disable);
}

/*
function getServer(serverId, account) {
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService()
              .QueryInterface(Components.interfaces.nsIRDFService);
  if (!serverId) serverId=account.incomingServer.serverURI;
  var serverResource = RDF.GetResource(serverId);
  try {
    var serverFolder =
      serverResource.QueryInterface(Components.interfaces.nsIMsgFolder);
    return serverFolder.server;
  } catch (ex) {
  }
  return null;
}
*/

/* Overloaded from chrome/messenger/content/messenger/am-copies.js, also called from am-identity-edit.js */
function onInitCopiesAndFolders()
{
  savedOnInitCopiesAndFolders();  // call original version, calls setupFccItems()

/* now use hidable, hidefor and iscontrolcontainer attributes in xul
    //im Hauptfenster ist gCurrentServerId definiert, in den Identities Fenster aber gAccount
  var server=getServer(gCurrentServerId, typeof(gAccount)!='undefined'?gAccount:null);
  if (!server || (
      server.type!='pop3' &&
      server.type!='imap' &&
      server.type!='movemail'
        )) {
    document.getElementById("ggbs_cs2c_fcc_all").hidden=true;
  } else {
*/
  if (!document.getElementById("ggbs_cs2c_fcc_all").hidden) {
    // in TB3 hide the 'reply to original folder' checkbox
    var rfp=document.getElementById("identity.fccReplyFollowsParent"); // a checkbox
    //if (rfp) var box=rfp.parentNode;
    if (rfp) var box=getEnclosingContainer(rfp);  //needs folderProps.js
    if (box) box.hidden=true;

    if (gFccRadioElemChoice>=gBase) {
      var radioElem = document.getElementById("ggbs_cs2c_fcc_selectOnSend");
      radioElem.radioGroup.selectedItem = radioElem;

      if (gFccRadioElemChoice&gSentAlso)
        document.getElementById("ggbs_cs2c_fcc2_toSend").checked=true;
      if (gFccRadioElemChoice&gTrash)
        document.getElementById("ggbs_cs2c_fcc_noCopyIsTrash").checked=true;
      if (TB3) {                                                                //wg BUG in TB3 with nocopy://
        document.getElementById("ggbs_cs2c_fcc_noCopyIsTrash").checked=true;    //always checked
        document.getElementById('ggbs_cs2c_fcc_noCopyIsTrash').setAttribute("disabled", true);  // always disabled
      }

      if (gFccRadioElemChoice&gDefSent) {
        radioElem = document.getElementById("ggbs_cs2c_fcc_defissent");
        radioElem.radioGroup.selectedItem = radioElem;
      } else {
        radioElem = document.getElementById("ggbs_cs2c_fcc_defiscur");
        radioElem.radioGroup.selectedItem = radioElem;
      }
    }
  }
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function onSaveCopiesAndFolders()
{
  if (gFccRadioElemChoice>=gBase) { //added!
    var formElement = document.getElementById("identity.fccFolderPickerMode");
    formElement.setAttribute("value", gFccRadioElemChoice);
  } else  //do the default
    savedOnSaveCopiesAndFolders();  // call original version
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function setupFccItems()
{
  savedSetupFccItems();   // call original version

  var checked = document.getElementById("identity.doFcc").checked;
  if (checked && gFccRadioElemChoice>=gBase) {
    var Picker = document.getElementById('msgFccAccountPicker');
    Picker.setAttribute("disabled", "true");
    Picker = document.getElementById('msgFccFolderPicker');
    Picker.setAttribute("disabled", "true");
  } else {
    gg_gui("true");
  }
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function setPickersState() {
  // when this is called we (sometimes) must disable our elements
  if (arguments[0]=='msgFccAccountPicker' || arguments[1]=='msgFccAccountPicker')
    gg_gui("true");
  return savedsetPickersState.apply(this, arguments);
}
