/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
var gPrefB = Components.classes["@mozilla.org/preferences;1"].
    getService(Components.interfaces.nsIPref).getBranch("extensions.copysent2current.");
var gCS2C = Components.classes["@ggbs.de/copySent2Current;1"].
      getService(Components.interfaces.CopySent2Current);
var gMessengerBundle=null;

function addElems() {
  var defelem=document.getElementById('lastused://');
  if (defelem) {
    var ak_nc;
    try { ak_nc = gPrefB.getCharPref("accesskey_nocopy"); }
      catch(e) { ak_nc='-'; }
    var m_nc=document.getElementById('nocopy://');
    m_nc.setAttribute('accesskey',ak_nc);
    var ak_d;
    try { ak_d = gPrefB.getCharPref("accesskey_default"); }
      catch(e) { ak_d='#'; }
    var m_d=document.getElementById('default://');
    if (m_d) m_d.setAttribute('accesskey',ak_d);
    var ak_lu;
    try { ak_lu = gPrefB.getCharPref("accesskey_lastused"); }
      catch(e) { ak_lu='+'; }
    defelem.setAttribute('accesskey',ak_lu);
    defelem.hidden = true;

    //add menu items to pre-send selector
    var ak_num;
    try { ak_num = gPrefB.getBoolPref("numbered_accesskeys"); }
      catch(e) { ak_num=false; }
    var menu=document.getElementById('ggbs_cs2c_copyMenuPopup');
    if (gCS2C.maxLength>1) {
      if (ak_num)
        defelem.setAttribute('accesskey',gCS2C.maxLength);
      else
        defelem.removeAttribute('accesskey');
    }
    for (var i=1; i<gCS2C.maxLength; i++) {
      var newelem=defelem.cloneNode(true);
      newelem.hidden = true;
      if (ak_num) newelem.setAttribute('accesskey',i);
      menu.insertBefore(newelem, defelem);
    }
  }
}

function fillElems() {
  var elem=document.getElementById('ggbs_cs2c_sep');
  if (gCS2C.maxLength<=1)
    elem.hidden=true;
  else
    elem.hidden=gCS2C.length==0;

    // TODO: eventuell das element weglassen das mit dem aktuellen default bereinstimmt
  for (var i=0; i<gCS2C.maxLength; i++) {
    elem=elem.nextSibling;
    if (i<gCS2C.length) {
      var uri=gCS2C.get_URI(i);
      var folder=GetMsgFolderFromUri(uri);
      if (!gMessengerBundle)
        gMessengerBundle = document.getElementById("bundle_messenger");
      // make the 'folder in server' text
      var label=gMessengerBundle.getFormattedString("verboseFolderFormat",
                  [folder.name, folder.server.prettyName]);

      elem.hidden = false;
      elem.label  = label;
      elem.id     = uri;
    } else {
      elem.hidden = true;
    }
  }
}
